//*** ARTILLERIE ***   ArmA ab 1.05  Vienna  22.03.2007
//
//Parameter: [[<Liste Geschtznamen>],"<Geschtzbezeichnung>",<Anzahl der Serien>,<max.Reichweite>,<Seite>,<Wartezeit bis wieder Bereit>,<MuniNr(1-2)>]
//
//Aufrufbeispiel West: _temp = [[AW1,AW2,...],"M119",2,1000,WEST,0,1] execVM "ArtillerieHQ\ArtillerieHQ.sqf"
//Aufrufbeispiel East: _temp = [[AE1,AE2,...],"D30", 2,1000,EAST,0,1] execVM "ArtillerieHQ\ArtillerieHQ.sqf"
//
//Programmlauf lokal beim aufrufenden Spieler (ausgenommen die Schussabgabe beim Server).
//
//Die GESCHTZE mssen mit KI erstellt werden und drfen dadurch keinen Sichtkontakt
// mit feindlichen Einheiten haben, weil sie sonst selbstndig auf diese feuern!
// In der Initialisierung der Geschtze ist einzutragen: this setDir getDir this
// sonst ist die Animation der Geschtze gestrt!
//
//Verwendet "ArtillerieSchuss.sqf" (beim Server) und eigenes Kartenfenster der "class ArtillerieKarte"
// (siehe description.ext). Damit Zieleingabe in automatischem Kartenfenster.
// Weiters die publiken Variablen "Artillerie_Bereit_WEST" und "Artillerie_Bereit_EAST" fr
// Meldungen und Aufrufbegrenzung im Multiplayermodus, dann die beiden Objekte und 
// zwei Auslser aus dem Artillerie-Beispiel mit Namen "Artillerie_..." und den Auslser "Server Befehlsempfnger"
// dann eine Spiellogik "Einheit" mit Namen "Server" sowie die Skripte
// "ArtillerieWest.sqs" und "ArtillerieEast.sqs" fr den addAktion Befehl.
// Initialisierung in Objekt fr West: Artillerie_Bereit_WEST=1; this addAction ["Artillerie anfordern","ArtillerieHQ\ArtillerieWEST.sqs"]
// Initialisierung in Objekt fr East: Artillerie_Bereit_EAST=1; this addAction ["Artillerie anfordern","ArtillerieHQ\ArtillerieEAST.sqs"]


Private ["_marker","_ok","_i","_w","_wi","_bereit","_m"];

//Marker erstellen 
if(isNil "ArtillerieZiel231206")then
	{
		ArtillerieZiel231206  =  [0,0];
		_marker = createMarkerLocal   ["ArtillerieZiel231206",[0,0]];
		_marker   setMarkerShapeLocal "ICON";
		_marker   setMarkerTypeLocal  "Destroy";
		_marker   setMarkerColorLocal "ColorRed";
		_marker   setMarkerSizeLocal  [0.7,0.7];
	};

//if: Artillerie frei? then: Artillerie aktivieren.
if(ArtillerieZiel231206 select 1 == 0)then
{
	ArtillerieZiel231206 = [0,1];
	onMapSingleClick "ArtillerieZiel231206 = _pos";
	_ok = createDialog "ArtillerieKarte";
	
	//Position des Beobachters auf der Karte markieren
	_m = createMarkerLocal["TempVienna01",position player];
	_m setMarkerShapeLocal "ICON";
	_m setMarkerSizeLocal [0.5,0.5];
	_m setMarkerTextLocal "<--- Beobachter";
	_m setMarkerColor "ColorRed";
	_m setMarkerTypeLocal "Dot";

	
	//Schleife max. 1 Minute (Zeit fr Eingabe in Karte)
	_i=0;
	_wi=1;
	while{_i < 300 and dialog}do
		{
			Sleep 0.2; // 0.2 Sek. Pause
			//Klick auf die Karte erfolgt?
			if(ArtillerieZiel231206 select 0 != 0)then
				{
					//Entfernung zum Ziel feststellen
					_wi=0;_w=0;
					{if(alive _x)then{_wi=_wi+1;_w=_w+(_x distance ArtillerieZiel231206)}}forEach(_this select 0);
					if(_wi>0)then{_w=_w/_wi};
					//if:erlaubte Reichweite? then:Marker setzen. else: Fehlerhafte Entfernung ausgeben.
					if(_w < _this select 3)then
						{
							//if:Geschtze unzerstrt? then:Marker setzen. else: Defektmeldung ausgeben
							if(_wi>0)then
								{
									"ArtillerieZiel231206" setMarkerPosLocal  ArtillerieZiel231206;
									"ArtillerieZiel231206" setMarkerTextLocal "Artillerieziel";
									_i=4999;
									onMapSingleClick "";
									Sleep 3;
									deleteMarkerLocal _m;
									closeDialog 0
								}
							else
								{
									[PlayerSide,"HQ"] sideChat "Artillerie offensichtlich defekt!";
									ArtillerieZiel231206 = [0,1];
									onMapSingleClick "";
								}
						}
					else
						{
							[PlayerSide,"HQ"] sideChat format["Entfernung: %1  Reichweite maximal %2 Meter!",_w,_this select 3];
							ArtillerieZiel231206 = [0,1];
							onMapSingleClick "ArtillerieZiel231206 = _pos"
						};
				};
			_i=_i+1
		};
		
	//if: Marker gesetzt? then: Feuer frei. else: Abbruch.
	if(_i == 5000)then
		{
			//Befehl zum Abfeuern der Kanonen an den Server senden.
			BefehlAnServer = format['{[_x,%1,"%2",%3,%4] execVM "ArtillerieHQ\ArtillerieSchuss.sqf"} forEach %5',ArtillerieZiel231206,_this select 1,_this select 2,_this select 6,_this select 0];
			publicVariable "BefehlAnServer";
			sleep 1;
			Player groupChat format["Artillerie feuer frei! Serien: %1",_this select 2];
			sleep ((_this select 2) * 24 + 10);
			sleep (_this select 5)
		}
	else
		{
			onMapSingleClick "";
			deleteMarkerLocal _m;
			closeDialog 0
		};
		
	ArtillerieZiel231206 = [0,0];
	"ArtillerieZiel231206" setMarkerTextLocal "VORHERIGES Artillerieziel";
	
	
	//Bereitmeldung wenn wenigstens 1 Geschtz noch bereit
	if(_wi > 0 and _i == 5000)then{sleep 1;_bereit=1}else{_bereit=0};
	
	//Bereitschaftsstatus publik machen: 0 oder 1 = bereit, aber bei 0 keine Bereitmeldung.
	if(_this select 4 == WEST)then
		{
			Artillerie_Bereit_WEST = _bereit;
			publicVariable "Artillerie_Bereit_WEST"
		}
	else
		{
			Artillerie_Bereit_EAST = _bereit;
			publicVariable "Artillerie_Bereit_EAST"
		}
};
